import pyperclip as pc
from IPython.display import Image, display
import numpy as np
from sklearn.metrics.pairwise import cosine_similarity
from sklearn.feature_extraction.text import TfidfVectorizer

def check(sentence1, sentence2):
    vectorizer = TfidfVectorizer()
    tfidf_matrix = vectorizer.fit_transform([sentence1, sentence2])
    cosine_similarities = cosine_similarity(tfidf_matrix)
    similarity_percentage = cosine_similarities[0, 1] * 100
    return similarity_percentage

def q(n):
    n = str(n)
    s = [['''Глеб и Анна исследуют эффективность лекарственного препарата АВС. Глеб, используя модель Анны, создал компьютерную программу, вычисляющую по заданным генетическим факторам вероятность (в процентах) успешного применения АВС. Программа Глеба накапливает полученные вероятности и в итоге выдает набор частот: по, П., П100. Например, 175 - это число случаев, в которых программа Глеба получила вероятность 75%. Обработав 1000 образцов генетического материала, Анна нашла значения факторов и ввела их в программу. В результате был получен следующий набор частот: 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 0, 0, 1, 1, 3, 4, 4, 5, 4, 6, 6, 11, 9, 19, 23, 25, 33, 36, 36, 46, 46, 49, 58, 90, 76, 66, 69, 75, 68, 44, 39, 21, 16, 5, 2, 1, 0, 0, 0. Для завершения этапа исследования необходимо было подобрать распределение, соответствующее полученным частотам. Анна решила использовать распределение на отрезке [0, 1] с плотностью f(x) = f(x; a,b) = abza 1(1-2)6-1 и целочисленными параметрами а, 6 в диапазоне от 1 до 20. В результате максимизации функции правдоподобия (при указанных ограничениях) Глебом были получены значения параметров: 4 = А и 6 = В. Задача: пусть Х- случайная величина, распределения на отрезке [0, 1] с плотностью f(x) = f(x;û, b), F(x) - ее функция распределения. Требуется найти математическое ожидание E(X) и Хо,2 = F-1 (0,2) квантиль уровня 0,2. Какой смысл для всей популяции имеют Е(Х) и Хо,2? В ответе укажите: 1) значение А; 2) значение В; 3) математическое ожидание Е(Х); 4) квантиль Хо,2-''', '1.png', '''import numpy as np
from scipy.optimize import minimize
data = np.array([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 2, 0, 0, 1, 1, 3, 4, 4, 5, 4, 6, 6, 11, 9, 19, 23, 25, 33, 36, 36, 46, 46, 49, 58, 90, 76, 66, 69, 75, 68, 44, 39, 21, 16, 5, 2, 1, 0, 0, 0])

sample = []
for i in range(0,101):
    if i != 0:
        sample += [i] * data[i]

sample = np.array(sample)
sample = sample / 100
 
data = sample
 
def custom_pdf(x, a, b):
    return a * b * x**(a-1) * (1 - x**a)**(b-1)
 
def likelihood(params):
    a, b = params
    end_values = custom_pdf(data, a, b)
    log_likelihood = np.log(end_values).sum()
    return -log_likelihood 

initial_guess = [1, 1] 
result = minimize(likelihood, initial_guess, method='BFGS')
 
a_estimated, b_estimated = result.x
 

print(f"Estimated a = {round(a_estimated,0)}")
print(f"Estimated b = {round(b_estimated,0)}")
from scipy import integrate
a,b = round(a_estimated,0), round(b_estimated,0)
def f(x):
    return x * (a * b * x**(a-1) * (1 - x**a)**(b-1))
 
From,To = 0,1
result, _ = integrate.quad(f, From, To)
print(f"E(x) = {result}")
from scipy.stats import rv_continuous
class CustomDistribution(rv_continuous):
            def _pdf(self, x):
                a, b = a_estimated, b_estimated
                return a * b * x**(a-1) * (1 - x**a)**(b-1)
            
cont = CustomDistribution(a = 0, b = 1)
q02 = cont.ppf(0.2)
print(f"квантиль 0.2 = {q02}")'''],['''Пусть (21, 1);...; (231, У31) - реализация случайной выборки (Х₁, Ү₁);...; (Х31, Ү31) из двумерного нормального распределения (;;;;). Используя векторы 2 = (21;...; 231) иў = (Улі; У31), постройте асимптотический 0,93-доверительный интервал (01;02) для коэффициента корреляции р. В ответе укажите: 1)выборочный коэффициент корреляции р; 2) верхнюю границу в₂ построенного доверительного интервала для р. Исходные данные: 2 = (-0,616; -0,238; 0,173; -0,255; 0,531; 0,718; -0,161; 0,371; -1,014; -0,413; -1,571; 0,485; 0,486; 0,688; -0,944; 0,155; 0,003; 0,111; 0,752; 0,783; -0,102; -0,74; -2,097; 1,349; -0,044; -0,617; -0,782;-0,873;-0,995; -1,256; -0,596), y = (-1,34; -0,25; 0,101; -0,626; -0,088; 0,539; -0,451; 0,233; -1,186; -0,423; -1,329; 0,231; 0,209; 0,638; -0,274; -0,491; -0,319; 0,294; 0,895; 1,164; -0,57; -1,078; -1,526; 1,491; 0,182; -0,31; -1,001; -0,969; -0,918; -0,904;-0,595).''', '2.png', '''import pandas as pd
x = np.array([-0.616, -0.238, 0.173, -0.255, 0.531, 0.718, -0.161, 0.371, -1.014, -0.413, -1.571, 0.485, 0.486, 0.688, -0.944, 0.155, 0.003, 0.111, 0.752, 0.783, -0.102, -0.74, -2.097, 1.349, -0.044, -0.617, -0.782, -0.873, -0.995, -1.256, -0.596])

y = np.array([-1.34, -0.25, 0.101, -0.626, -0.088, 0.539, -0.451, 0.233, -1.186, -0.423, -1.329, 0.231, 0.209, 0.638, -0.274, -0.491, -0.319, 0.294, 0.895, 1.164, -0.57, -1.078, -1.526, 1.491, 0.182, -0.31, -1.001, -0.969, -0.918, -0.904, -0.595])

df = pd.DataFrame({'y':y,'x':x})
r = df.corr().iloc[0][1]
print(f" выборочный коэффициент корреляции 𝜌 = {r}")
import scipy.stats as stats
alpha = 1 - 0.93

z = np.arctanh(r)
z_critical = stats.norm.ppf(1 - alpha/2)
se = 1 / np.sqrt(len(x) - 3)

upper = np.tanh(z + z_critical*se)
print(f"upper bound: {upper}")'''],['''Пусть 2 = (1,230) - реализация случайной выборки Х = (Х1,..., Х30) из нормального распределения N( 3,42).

Проверяется на уровне значимости а = 0,01 основная гипотеза Но: м = 1,29 против альтернативной гипотезы

Н.: μ≠ 1,29 с критическим множеством вида К₁ = (-∞,-A) U (A,+00). 1) Найдите значение статистики критерия ZZ(2). 2) Найдите границу А критического множества. 3) Найдите Р-значение критерия и сделайте выводы. 4) Найдите мощность W критерия для Н₁: µ = 1,17.

Исходные данные: 2 = (1,416; 0,624; 6,471; 6,256; 1,787; 2,546; -1,758; -5,475; 0,077; 1,792; 5,443; 5,348; -0,057; 0,232; -2,305; -3,568; -4,541; 7,893; -0,473; -0,229; 3,0; 3,903; 4,227; 0,537; -1,785; 2,575; -0,477; -2,754; 1,164; 2,716)''', '3.png', '''import numpy as np
import pandas as pd
from scipy.stats import *

Z = norm()
def Phi0(x):
    return Z.cdf(x) - 1 / 2


x = np.array([1.416, 0.624, 6.471, 6.256, 1.787, 2.546, -1.758, -5.475, 0.077, 1.792, 5.443, 5.348, -0.057, 0.232, -2.305, -3.568, -4.541, 7.893, -0.473, -0.229, -3.0, 3.903, -4.227, 0.537, -1.785, 2.575, -0.477, -2.754, 1.164, 2.716])
n = len(x)

s = 3.4
alpha = 0.01
mu0 = 1.29
mu1 = 1.17

z = np.sqrt(n) * (x.mean() - mu0) / s
print(f'1) Значение статистики критерия Zнабл. = {z}')

A = Z.isf(alpha / 2)
print(f'2) Граница А критического множества = {A}')

P = 2 * min(Z.cdf(z), Z.sf(z))
print(f'3) P-значение критерия = {P}')

beta = Phi0(A - np.sqrt(n) * (mu1 - mu0) / s) + Phi0(A + np.sqrt(n) * (mu1 - mu0) / s)
W = 1 - beta
print(f'4) Мощность W = {W}')'''],['''Пусть 2 = (1,230) - реализация случайной выборки Х = (Х1,..., Х30) из нормального распределения N( 3,42).

Проверяется на уровне значимости а = 0,01 основная гипотеза Но: м = 1,29 против альтернативной гипотезы

Н.: μ≠ 1,29 с критическим множеством вида К₁ = (-∞,-A) U (A,+00). 1) Найдите значение статистики критерия ZZ(2). 2) Найдите границу А критического множества. 3) Найдите Р-значение критерия и сделайте выводы. 4) Найдите мощность W критерия для Н₁: µ = 1,17.

Исходные данные: 2 = (1,416; 0,624; 6,471; 6,256; 1,787; 2,546; -1,758; -5,475; 0,077; 1,792; 5,443; 5,348; -0,057; 0,232; -2,305; -3,568; -4,541; 7,893; -0,473; -0,229; 3,0; 3,903; 4,227; 0,537; -1,785; 2,575; -0,477; -2,754; 1,164; 2,716)''', '4.png', '''x = np.array([1.146, 2.958, -3.325, -0.534, 0.374, 5.293, 0.12, 1.185, 5.148, 5.351, 2.639, 1.47, -1.967, 4.96, 6.057, -0.542, 1.544, -0.243, -1.988, 2.844])
n = len(x)

alpha = 0.05
mu0 = 1.10
mu1 = 0.91



T = np.sqrt(n) * (x.mean() - mu0) / x.std(ddof=1)
print(f'1) Значение статистики критерия Tнабл. = {T}')

A = t(n - 1).isf(alpha / 2)
print(f'2) Граница А критического множества = {A}')

P = 2 * min(t(n - 1).cdf(T), t(n - 1).sf(T))
print(f'3) Значение P-критерия = {P}')

delta = np.sqrt(n - 1) * (mu1 - mu0) / x.std()
t2 = t(n - 1).isf(alpha / 2)
beta = nct(n - 1, delta).cdf(t2) - nct(n - 1, delta).cdf(-t2)
W = 1 - beta
print(f'4) Мощность W = {W}')'''],['''Пусть 2 = (21,..., 220) - реализация случайной выборки Х = (Х1,..., Х20) из нормального распределения N(μ; 02). Проверяется на уровне значимости а = 0,05 основная гипотеза Но: р = 1,10 против альтернативной гипотезы Н₁: 4≠ 1,10 с критическим множеством вида Ка = (-0, A) U (А, +00). 1) Найдите значение статистики критерия t = Табл. = T(Z). 2) Найдите границу А критического множества. 3) Найдите Р-значение критерия и сделайте выводы. 4) Найдите мощность W критерия для Н₁ : µ = 0,91. Исходные данные: 2 = (1,146; 2,958; -3,325; -0,534; 0,374; 5,293; 0,12; 1,185; 5,148; 5,351; 2,639; 1,47; -1,967; 4,96; 6,057;-0,542; 1,544; -0,243; -1,988; 2,844).''', '5.png', '''x = np.array([0.889, 1.514, 2.846, 2.811, 0.84, 0.945, 0.02, -0.441, -0.796, 3.739, 0.688, 0.777, -0.233, 2.284, -0.681, 1.056, 0.21, 1.8, 0.687, -0.144, 1.285, 1.851, 1.402, 1.695, 0.533, 0.87, 0.486, 0.874, 0.312, -0.821])
n = len(x)

alpha = 0.02
mu = 1.18
s0 = 1.14
s1 = 1.24



s2 = np.sum((x - mu) ** 2) / n
CHI = n * s2 / s0 ** 2
print(f'1) Значение статистики критерия Хи-квадрат = {CHI}')

A = chi2(n).isf(1 - alpha / 2)
B = chi2(n).isf(alpha / 2)
print(f'2.1) A = {A}\n2.2) B = {B}')

P = 2 * min(chi2(n).cdf(CHI), chi2(n).sf(CHI))
print(f'3) P-значение критерия = {P}')

beta = chi2(n).cdf(s0 ** 2 / s1 ** 2 * B) - chi2(n).cdf(s0 ** 2 / s1 ** 2 * A)
print(f'4) Вероятность ошибки второго рода = {beta}')'''],['''Пусть 2 = (21,...,230) - реализация случайной выборки Х = (Х1,..., Х30) из нормального распределения (1,18;02). Проверяется на уровне значимости а = 0,02 гипотеза Но: о = 1,14 против альтернативной гипотезы Н₁: σ≠ 1,14€ критическим множеством вида Ка = (0; A) U (B; +∞). 1) Найдите значение статистики критерия хв. 2) Найдите границы А и в критического множества и проверьте гипотезу Но. 3) Найдите Р-значение критерия. 4) Найдите вероятность ошибки второго рода в для о₁ = 1,24. Исходные данные: (0,889; 1,514; 2,846; 2,811; 0,84; 0,945; 0,02; -0,441; -0,796; 3,739; 0,688; 0,777; -0,233; 2,284; -0,681; 1,056; 0,21; 1,8; 0,687; -0,144; 1,285; 1,851; 1,402; 1,695; 0,533; 0,87; 0,486; 0,874; 0,312;-0,821''', '6.png', '''x = np.array([0.889, 1.514, 2.846, 2.811, 0.84, 0.945, 0.02, -0.441, -0.796, 3.739, 0.688, 0.777, -0.233, 2.284, -0.681, 1.056, 0.21, 1.8, 0.687, -0.144, 1.285, 1.851, 1.402, 1.695, 0.533, 0.87, 0.486, 0.874, 0.312, -0.821])
n = len(x)

alpha = 0.02
s0 = 1.14
s1 = 1.24



CHI = (n - 1) * x.var(ddof=1) / s0 ** 2
print(f'1) Значение статистики критерия Хи-квадрат = {CHI}')

A = chi2(n - 1).isf(1 - alpha / 2)
B = chi2(n - 1).isf(alpha / 2)
print(f'2.1) A = {A}\n2.2) B = {B}')

P = 2 * min(chi2(n - 1).cdf(CHI), chi2(n - 1).sf(CHI))
print(f'3) P-значение критерия = {P}')

beta = chi2(n - 1).cdf(s0 ** 2 / s1 ** 2 * B) - chi2(n - 1).cdf(s0 ** 2 / s1 ** 2 * A)
print(f'4) Вероятность ошибки второго рода = {beta}')'''],['''Пусть 2 = (21,..., 225) - реализация случайной выборки Х = (Х1,..., Х25) из нормального распределения N(; 0,72), a y = (У, Узо) реализация случайной выборки У = (Х1,..., Ү30) из нормального распределения (№₁₄; 1,4²). Известно, что Х и У независимы. Проверяется гипотеза Но: ₂ = у против альтернативной гипотезы Н₁ : ₂ > Ну. При уровне значимости а применяется критерий с критической областью {2 > А), где статистика критерия Z = Z(X, Y) - это нормированная разность ХЎ, А = Ад - зависящее от а критическое значение. Соответствующее критическое множество имеет вид Ка = (Аа; 00). 1) Найдите значение статистики критерия Z обл. = Z(Z,ў). 2) Найдите Р-значение критерия. 3) Найдите критическое значение А, критическое множество Ка и проверьте гипотезу Но при а = 0,02. 4) Найдите мощность критерия W в случае -= 0,1 и а = 0,02. Исходные данные: (3,842; 3,374; 4,18; 4,5; 4,247; 4,412; 3,756; 3,946; 3,729; 3,948; 3,631; 2,992; 4,324; 3,919; 3,059, 4,524; 3,565; 4,236; 4,71; 4,29; 4,998; 3,336; 4,482; 3,721; 3,59); y = (3,19; 3,564; 4,079; 2,369; 5,261; 4,652; 1,849; 6,084; 6,654; 5,65; 3,748; 2,501; 5,476; 3,436; 5,711; 4,292; 5,367; 4,499; 4,989; 4,015; 6,5; 4,178; 4,563; 6,636; 2,113; 2,221; 5,357; 2,358; 6,721; 3,421).''', '7.png', '''x = np.array([3.842, 3.374, 4.18, 4.5, 4.247, 4.412, 3.756, 3.946, 3.729, 3.948, 3.631, 2.992, 4.324, 3.919, 3.059, 4.524, 3.565, 4.236, 4.71, 4.29, 4.998, 3.336, 4.482, 3.721, 3.59])
n = len(x)
 
y = np.array([3.19, 3.564, 4.079, 2.369, 5.261, 4.652, 1.849, 6.084, 6.654, 5.65, 3.748, 2.501, 5.476, 3.436, 5.711, 4.292, 5.367, 4.499, 4.989, 4.015, 6.5, 4.178, 4.563, 6.636, 2.113, 2.221, 5.357, 2.358, 6.721, 3.421])
m = len(y)
 
sx = 0.7
sy = 1.4
alpha = 0.02
delta = 0.1



z = (x.mean() - y.mean()) / np.sqrt(sx ** 2 / n + sy ** 2 / m)
print(f'1) Значение статистики критерия Zнабл. = {z}')

P = Z.sf(z)
print(f'2) Значение P-критерия = {P}')

A = Z.isf(alpha)
print(f'3) Критическое щначение A = {A}')

beta = 1 / 2 + Phi0(A - np.sqrt(m * n) / np.sqrt(m * sx ** 2 + n * sy ** 2) * delta)
W = 1 - beta
print(f'4) Мощность W = {W}')'''],['''Для трех групп финансовых показателей А: (Х1;...; Х27), В: (Y1;...; Y33), С: (Z1;...; Z39), которые по предположению

независимы и распределены, соответственно, по трем нормальным законам (μ₂, σ²), N(μ, 02), (4, 2) ( одинаковой неизвестной дисперсией о²) на уровне значимости а = 0,01 с помощью F-критерия (Фишера) проверяется гипотеза Но: z = y = 0 Совпадении ожидаемых значений показателей. Конкретные значения всех показателей указаны ниже. 1) По данным значениям показателей найдите межгрупповую дисперсию. 2) По этим же данным найдите среднюю групповую дисперсию. 3) Найдите значение статистики F-критерия, критическое множество Ка и проверьте гипотезу Но. 4) Найдите Р-значение критерия и сделайте выводы.

Значения показателей группы А: (0,616; 1,046; 2,575;-0,344; 2,339; -0,68; 3,739; 2,251; -1,252; 3,536; -0,491; 5,556; 4,856; -1,68; 2,33; 1,345; 2,829; 2,539; 3,304; 3,497; 0,211; 3,563; 0,94; 3,642; 1,956; 3,919; 3,568). Значения показателей группы В: (2,834; 1,504; -0,678; 5,619; 0,97; 1,617; 3,768; -1,309; 3,343; -1,778; -0,854; 1,04; 2,83; -2,335; 4,853; 5,6; 4,341; 4,362; 3,52; 1,151; -0,621; -2,88; 1,697; 1,753; 0,211; 2,157; 1,989; 2,457; 1,399; 1,61; -0,558; 2,132; 2,293). Значения показателей группы С: (2,398; -2,77; 4,679; 1,924; 0,574; 5,329; 0,699; 4,457; -0,3; 1,682; -1,34; 0,046; -1,096; 1,935; 2,411; 4,134; 5,643; 3,071; 6,526; 4,941; 2,844; -0,43; -2,066; 0,22; 0,317; -1,923; 1,38; -2,485; 0,111; -0,542; 4,78; 1,93; 0,462; 5,487; -3,547; 2,933; -0,987; -0,21; 3,955).
''', '8.png', '''x = np.array([0.616, 1.046, 2.575, -0.344, 2.339, -0.68, 3.739, 2.251, -1.252, 3.536, -0.491, 5.556, 4.856, -1.68, 2.33, 1.345, 2.829, 2.539, 3.304, 3.497, 0.211, 3.563, 0.94, 3.642, 1.956, 3.919, 3.568])
n1 = len(x)
 
y = np.array([2.834, 1.504, -0.678, 5.619, 0.97, 1.617, 3.768, -1.309, 3.343, -1.778, -0.854, 1.04, 2.83, -2.335, 4.853, 5.6, 4.341, 4.362, 3.52, 1.151, -0.621, -2.88, 1.697, 1.753, 0.211, 2.157, 1.989, 2.457, 1.399, 1.61, -0.558, 2.132, 2.293])
n2 = len(y)
 
z = np.array([2.398, -2.77, 4.679, 1.924, 0.574, 5.329, 0.699, 4.457, -0.3, 1.682, -1.34, 0.046, -1.096, 1.935, 2.411, 4.134, 5.643, 3.071, 6.526, 4.941, 2.844, -0.43, -2.066, 0.22, 0.317, -1.923, 1.38, -2.485, 0.111, -0.542, 4.78, 1.93, 0.462, 5.487, -3.547, 2.933, -0.987, -0.21, 3.955])
n3 = len(z)
 
xyz = pd.DataFrame([x, y, z]).T
xyz_all = np.concatenate([x, y, z])
n = [n1, n2, n3]
N = sum(n)
k = 3
 
alpha = 0.01
 
d2 = np.sum((xyz.mean() - xyz_all.mean()) ** 2 * n) / N
print(f'1) Межгрупповая дисперсия = {d2}')

meanvar = np.sum(xyz.var(ddof=0) * n) / N
print(f'2) Средняя групповая дисперсия = {meanvar}')
#(d2 + meanvar), xyz_all.var(ddof=0)

SSE = N * meanvar
MSE = SSE / (N - k)
SSTR = N * d2
MSTR = SSTR / (k - 1)
F = MSTR / MSE
print(f'3) Значение статистики F-критерия = {F}')

P = f(k - 1, N - k).sf(F)
print(f'4) P-значение критерия = {P}')'''],['''4. (10) В группе учится 22 студента. Ими были получены следующие 100-балльные оценки: 64, 41, 83, 41, 83, 53, 0, 63, 84, 98, 2, 42, 98, 57, 63, 53, 91, 28, 76, 63, 78, 83. Найдите: 1) А - среднюю положительную оценку в группе; 2) М - медиану положительных оценок в группе; 3) Н - среднее гармоническое и G среднее геометрическое оценок, которые не менее М; 4) Q - медианную оценку в той части группы, в которой студенты набрали не менее М баллов; 5) N - количество студентов, оценки которых оказались между Н и Q (включая границы).''', '9.png', '''grades = np.array(sorted([64, 41, 83, 41, 83, 53, 0,
63, 84, 98, 2, 42, 98, 57, 63, 53, 91, 28, 76, 63, 78, 83]))
grades_p = grades[grades > 0]
A = grades_p.mean()
print(A)

M = grades_p[len(grades_p)//2]
print(M)

M_grades = grades[grades >= M]

from scipy.stats import hmean, gmean
H = hmean(M_grades)
G = gmean(M_grades)
print(H, G)


Q = M_grades[len(M_grades)//2]
print(Q)

print(grades[(grades >= min(H,Q)) & (grades <= max(H,Q))])'''],['''4. (10) Эмпирическое распределение признаков Х и У на генеральной совокупности П = {1,2,..., 100) задано таблицей частот


Из 2 случайным образом без возвращения извлекаются 14 элементов. Пусть Х и У - средние значения признаков на выбранных элементах. Требуется найти: 1) математическое ожидание Е(Х); 2) дисперсию Var(); 3) коэффициент корреляции р(X, Y)''', '10.png', '''xs = np.array([200]*(18+13+17) + [400] *(13+16+23))
ys = np.array([1]*18 + [2]*13 + [4]*17 + [1] *13 + [2]*16 + [3]*23)
N = len(ys)
n = 7

print(f'1) E(x) = {xs.mean()}')

print(f'2) var(y) = {ys.var() / n * (N-n)/(N-1)}')


print(f'3) {np.corrcoef(xs, ys)}')
'''],[''' ''', '11.png', '''xs = np.array([200]*(18+13+17) + [400] *(13+16+23))
ys = np.array([1]*18 + [2]*13 + [4]*17 + [1] *13 + [2]*16 + [3]*23)
N = len(ys)
n = 7

print(f'1) E(y) = {ys.mean()}')

print(f'2) std(x) = {xs.std() / (n * (N-n)/(N-1))**0.5}')

print(f'3) cov(x,y) = {((xs*ys).mean() - xs.mean()*ys.mean()) / n * (N-n)/(N-1)}')'''],['''Эмпирическое распределение признаков Х и У на генеральной совокупности = {1,2,..., 100} задано таблицей частот



Из 2 случайным образом без возвращения извлекаются 6 элементов. Пусть Х и Ү - средние значения признаков на выбранных элементах. Требуется найти: 1) математическое ожидание Е(Y); 2) стандартное отклонение (Х); 3) ковариацию Cov(X,Y).

ВАШИ ОТВЕТЫ

1) Математическое ожидание = Математическое ожидание.

2) Стандартное отклонение Стандартное отклонение.

3) Ковариация = Ковариация.''', '11.png', '''xs = np.array([200]*(18+13+17) + [400] *(13+16+23))
ys = np.array([1]*18 + [2]*13 + [4]*17 + [1] *13 + [2]*16 + [3]*23)
N = len(ys)
n = 7

print(f'1) E(y) = {ys.mean()}')

print(f'2) std(x) = {xs.std() / (n * (N-n)/(N-1))**0.5}')

print(f'3) cov(x,y) = {((xs*ys).mean() - xs.mean()*ys.mean()) / n * (N-n)/(N-1)}')'''],['''4. (10) Распределение баллов на экзамене до перепроверки задано таблицей

Оценка работы

Число работ
Работы будут перепроверять 7 преподавателей, которые разделили все работы между собой поровну случайным образом. Пусть Х - средний балл (до перепроверки) работ, попавших к одному из преподавателей. Требуется найти: 1) математическое ожидание Е(Х); 2) стандартное отклонение о(Χ).''', '12.png', '''gs = np.array([2,3,4,5])
ns = np.array([80,12,55,56])

total = []
for i in range(len(gs)):
    total += [*[gs[i]]*ns[i]]
total = np.array(total)
E = total.mean()

N = sum(ns)
n = N / 6

Var = (total.var() / n * (N-n)/(N-1))

print(E,Var)'''],['''4. (10) Распределение баллов на экзамене до перепроверки задано таблицей

Оценка работы

Число работ
Работы будут перепроверять 7 преподавателей, которые разделили все работы между собой поровну случайным образом. Пусть Х - средний балл (до перепроверки) работ, попавших к одному из преподавателей. Требуется найти: 1) математическое ожидание Е(Х); 2) стандартное отклонение о(Χ).''', '13.png', '''pd = np.array(sorted([-956, 744, 1024, -794, 17, -252, -1122, 
                      -853, 65, -200, 991, 277, 59, -105, -95, 
                      729, 20, 584, -832, -232, -490, -590, 197, 
                      -20, -278,-123, -275, -72, -416, -165]))

print('1)', pd.mean())
print('2)', pd.std())

X = stats.norm(pd.mean(), pd.std())

L, H = X.ppf(0.25), X.ppf(0.75)
print('3)', L, H)



print('4)',len(pd[(pd >= L) & (pd <= H)]))

print('5) ?')
#5е не нашел у себя'''],['''4. (10) Следующие 30 чисел это умноженные на 10000 и округленные до ближайшего целого дневные логарифмические доходности акции компании АВС: 956, 744, 1024,794, 17, -252, 1122, -853, 65, -200, 991, 277, 59, -105, -95, 729, 20, 584, -832, -232, -490, -590, 197, -20, -278, -123, -275, -72, 416, -165. Будем называть их преобразованными доходностями (ПД). Финансовый аналитик Глеб предполагает, что преобразованные доходности (как и исходные) приближенно распределены по нормальному закону. Чтобы проверить свое предположение Глеб нашел нижнюю квартиль 1 и верхнюю квартиль Н нормального распределения (и, о²), для которого и это среднее арифметическое ПД, а о - эмпирическое стандартное отклонение ПД. Затем Глеб подсчитал количество ПД, попавших в интервал от 1 до Н (надеясь, что в этот интервал попадет половина ПД). Результат этого вычисления показался ему недостаточно убедительным. Чтобы окончательно развеять сомнения относительно нормальности ПД. Глеб построил на одном рисунке графики функций: F(x) и F(г), где F(г) эмпирическая функция распределения ПД. а F(z) - функция распределения (р, о²). В качестве меры совпадения двух графиков Глеб решил использовать расстояние в между функциями F(z) и F(2), которое он вычислил, исходя из определения: d = sup|F(z) F(z). В ответе укажите результаты вычислений Глеба: 1) среднее арифметическое ПД; 2) эмпирическое стандартное отклонение ПД; 3) квартили 1 и Н; 4) количество ПД, попавших в интервал от 1 до Н; 5) расстояние между функциями F(2) и F(x).
''', '14.png', '''vals = []
n = 11
N = 36
dice = np.arange(1,7)


for a in dice:
    for b in dice:
        vals += [15*a-7*b]
        
vals = np.array(vals)
print('1)', vals.mean())

print('2)',(vals.var() / n * (N-n)/(N-1))**0.5)'''],['''4. (10) Две игральные кости, красная и синяя, подбрасываются до тех пор, пока не выпадет 11 различных (с учетом цвета) комбинаций очков. Пусть R; - число очков на красной кости, а В; число очков на синей кости в комбинации с номером і. Случайные величины Х; задаются соотношениями: Х₁ = 15R; - 7B;, і = 1,..., 11. Среднее арифметическое этих величин обозначим Х = +2 Х.. Требуется найти: 1) математическое ожидание E(X); 2) стандартное отклонение сигма X''', '15.png', '''grades = np.array([100, 86, 51, 100, 95, 100, 12, 
                   61, 0, 0, 12, 86, 0, 52, 62, 76, 
                   91, 91, 62, 91, 65, 91, 9, 83, 67, 58, 56])

N = 28
n = 6

Var = grades.var() / n
print('1)', Var)

#или Если 1) просят мат ожидание
# E = grades.mean()
# print('1)', E)

mu3 = sum((grades - grades.mean())**3)/N/n**2 
print('2)', mu3)'''],['''4. (10) В группе 2 учатся 28 студентов, 2 = {1, 2,..., 28). Пусть Х(і) - 100-балльная оценка студента і Є П. Из группы Я случайным образом 6 раз выбирается студент є Є П. Повторный выбор допускается. Пусть ш; - студент, полученный после выбора j = 1,..., 6, X(wj) - его оценка. Среднюю оценку на случайной выборке обозначим Х = Χ(ω;).

Оценки в группе даны: 95, 12, 0, 3, 63, 64, 0, 63, 100, 96, 54, 79, 0, 98, 71, 68, 95, 97, 89, 78, 79, 89, 100, 67, 0, 63, 80, 64. Требуется найти: 1) дисперсию Var(X); 2) центральный момент из(X).''', '16.png', '''#1й список х, 2й - у
nums = [[71,52,72,87,81,100,90,54,54,58,56,70,93,46,56,
                59,42,60,33,83,50,93,41,55,60,37,71,42,85,39],
               [71,58,81,92,81,94,96,46,60,62,49,60,86,48,61,
                52,40,60,37,92,57,93,42,64,59,30,71,44,82,39]]

xy = np.array([[nums[0][i],nums[1][i]] for i in range(len(nums[0]))])
clean = xy[(xy[:,0]>=50) & (xy[:,1]>=50)]

clean
x = clean[:, 0]
y = clean[:, 1]

cov = sum((x-x.mean())*(y-y.mean())) / len(x)
print('1)', cov)
corr = np.corrcoef(x,y)[0,1]
print('2)', corr)'''],['''4. (10) В группе 2 учатся студенты: 1,..., W30. Пусть Х и У - 100-балльные экзаменационные оценки по

математическому анализу и теории вероятностей. Оценки студента ш; обозначаются: 2; = X (W₁) и у = Y(wi), i = 1,..., 30. Все оценки известны: х₁ = 73,169, 2239, 243, 23 = 87, уз 88, 24 = 60,441,

2579, 9595, 2686, 9698, 2747, 97 = 46, x8 = 42, y858, 2944, y943, 210= 66, 910 = 56,

21147,911 = 47,

21280, 912 = 85,

21744, 917 = 60,

21339, 913 = 35,

21856, 918 = 43,

21473, 914 = 65,

21562, 915=77,

21644, 916 = 55,

22140,921 = 39,

2284, Y22 = 82,

22374,923 = 56,

21939, 1944,

22086, 920 = 64,

22638, 92652, 22765, 92765, 22857,928

22473,924 = 68,

2551, 925 34,

53, 22933, 92950, 23072,930 = 94. Требуется найти следующие условные эмпирические характеристики: 1) ковариацию Х и У при условии, что одновременно Х > 50 и У > 50; 2) коэффициент корреляции Х и У при том же условии
''', '17.png', '''ns = np.array([22,29,28,25,20])
xs = np.array([74,73,72,79,80])
ds = np.array([9,4,7,3,8])

E = sum(xs * ns / sum(ns))
print('1)', E)


v1 = sum(((xs - X)**2)* ns) / sum(ns)
v2 = sum((ns * ds**2)) / sum(ns)
Var = np.sqrt(v1+v2)
print('2)', Var)'''],['''4. (10) Поток 2 состоит из к групп: 21,..., к., k = 5. На потоке учатся п = п₁+... +пк студентов, где п; - число студентов в группе Ω;, і = 1,..., к. Пусть Х(ш) - 100-балльная оценка студента шЄП. Далее используются следующие обозначения: 2; - среднее значение, от - (эмпирическое) стандартное отклонение признака Х на группе П. Дано: п₁ = 22, п₂ = 29, пз 28, 425, n5 = 20, 2174, 273, 372, 2479, 25 80, σ₁ = 9, σ₂ = 4, σ3 = 7, σ4 = 3, σ5 = 8. Tребуется найти: 1) среднее значение Х на потоке 2; 2) (эмпирическое) стандартное отклонение Х на потоке П.



Имеется 11 пронумерованных монет. Монеты подбрасываются до тех пор, пока не выпадет 257 различных (с учетом номера монеты) комбинаций орел решка. Пусть Х, - число орлов в комбинации с номером і; а X = X, среднее число орлов в полученных таким образом комбинациях. Требуется

найти: 1) математическое ожидание Е(Х); 2) дисперсию Var(X)''', '18.png', '''toss = [0,1]
t = []
for c1 in toss:
    for c2 in toss:
        for c3 in toss:
            for c4 in toss:
                for c5 in toss:
                    for c6 in toss:
                        for c7 in toss:
                            for c8 in toss:
                                for c9 in toss:
                                    for c10 in toss:
                                        for c11 in toss:
                                            t += [c1+c2+c3+c4+c5+c6+c7+c8+c9+c10+c11]
N = 2**11
n = 257
t = np.array(t)
E = t.mean()
print('1)', E)

Var = t.var() / n * (N-n)/(N-1)
print('2)', Var)'''],['''Для трех групп финансовых показателей А, В, С проверяется гипотеза о совпадении ожидаемых значений показателей. Предполагается, что все показатели Х., независимы и распределены по нормальному закону №(µ₃, о²) с одинаковой неизвестной дисперсией Var(X) = 6², причем для каждой группы Е(Х;;) = му, ј = 1, 2, 3. 1) По данным значенням (файл ds5.9.8.csv) найдите межтрупповую и среднюю групповую дисперсии. 2) Найдите 91% доверительные интервалы для ожидаемых значений показателей Hj,j = 1, 2, 3. 3) Найдите значение статистики критерия fo Р набл., критическое множество Ка и на 3% уровне значимости F проверьте гипотезу о совпадении ожидаемых значений показателей, 41 = 42 = 43. 4) Найдите Р-значение критерия и сделайте Выводы.''', '19.png', '''import pandas as pd
import numpy as np
from scipy.stats import *
def converting(string):
    return float(string.replace(',', '.'))
df = pd.read_csv('ds5.9.8.csv', header=None, sep=';')

alpha = 0.03

x = np.vectorize(converting)(np.array(df[0].dropna()))
n1 = len(x)
 
y = np.vectorize(converting)(np.array(df[1].dropna()))
n2 = len(y)
 
z = np.vectorize(converting)(np.array(df[2].dropna()))
n3 = len(z)
 
xyz = pd.DataFrame([x, y, z]).T
xyz_all = np.concatenate([x, y, z])
n = [n1, n2, n3]
N = sum(n)
k = 3
 

 
d2 = np.sum((xyz.mean() - xyz_all.mean()) ** 2 * n) / N
print(f'1) Межгрупповая дисперсия = {d2}')

meanvar = np.sum(xyz.var(ddof=0) * n) / N
print(f'2) Средняя групповая дисперсия = {meanvar}')
#(d2 + meanvar), xyz_all.var(ddof=0)

SSE = N * meanvar
MSE = SSE / (N - k)
SSTR = N * d2
MSTR = SSTR / (k - 1)
F = MSTR / MSE
print(f'3) Значение статистики F-критерия = {F}')

P = f(k - 1, N - k).sf(F)
print(f'4) P-значение критерия = {P}')

confidence_level = 0.91
t_critical = t.ppf((1 + confidence_level) / 2, N-k)
lower = z.mean() - t_critical * (MSE/len(z))**0.5
upper = z.mean() + t_critical * (MSE/len(z))**0.5
print(f'\nДоверительный интервал: [{lower}; {upper}]')''']]
    if n.isdigit():
        n = int(n)
        if len(s[n]) == 2:
            return pc.copy(s[n][-1])
        else:
            display(Image(filename=s[n][1]))
            return pc.copy(s[n][-1])
    else:
        c = []
        for i, u in enumerate(s):
            c.append([i, check(n, u[0])])
        res = sorted(c, reverse=True, key=lambda x: x[1])[:5]
        return res
